com.hazelcast.core

## Class IndeterminateOperationStateException

- java.lang.Object
- - java.lang.Throwable
  - - java.lang.Exception
    - - java.lang.RuntimeException
      - - com.hazelcast.core.HazelcastException
        - - com.hazelcast.core.IndeterminateOperationStateException

- All Implemented Interfaces:
    Serializable

      public class IndeterminateOperationStateException
      extends HazelcastException

  IndeterminateOperationStateException is thrown when result of an invocation becomes indecisive.

  For instance, an invocation doesn't receive enough ACKs from the backup replicas in time. In this case, IndeterminateOperationStateException only informs the caller that the operation may not be executed on all requested backup replicas, hence durability of the written / updated value may not be guaranteed immediately. This timeout is defined by configuration property `GroupProperty.OPERATION_BACKUP_TIMEOUT_MILLIS`.

  Similarly, if the member, which owns the primary replica of the operation's target partition, leaves the cluster before a response is returned, then

  operation is not retried but fails with IndeterminateOperationStateException. However, there will not be any rollback on other successful replicas.

  Last, if a Raft group leader leaves the cluster before sending a response for the invocation, the invocation may terminate without knowing if the operation is committed or not.

  See Also:
    `GroupProperty.OPERATION_BACKUP_TIMEOUT_MILLIS`, `GroupProperty.FAIL_ON_INDETERMINATE_OPERATION_STATE`, `CPSubsystemConfig.setFailOnIndeterminateOperationState(boolean)`, Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `IndeterminateOperationStateException()`
    `IndeterminateOperationStateException(String message)`
    `IndeterminateOperationStateException(String message, Throwable cause)`

  - ### Method Summary

    - ### Methods inherited from class java.lang.Throwable

      `addSuppressed, fillInStackTrace, getCause, getLocalizedMessage, getMessage, getStackTrace, getSuppressed, initCause, printStackTrace, printStackTrace, printStackTrace, setStackTrace, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### IndeterminateOperationStateException

          public IndeterminateOperationStateException()

    - #### IndeterminateOperationStateException

          public IndeterminateOperationStateException(String message)

    - #### IndeterminateOperationStateException

          public IndeterminateOperationStateException(String message,
                                                      Throwable cause)

Copyright © 2020. All rights reserved.